﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PojeClient {
    // 人間の練習用に，あまり死ななくて，攻撃もしてこないＡＩ
    class AI_NoAttack : Player {
        private int fMyIndex;
        private int fTimeLimit;
        private Action[] fAnswerBox;
        private Random fRand;

        public String getName() {
            return "AI : No-Attack";
        }

        public void newGame(int yourIndex) {
            fRand = new Random(yourIndex + (new Random()).Next());
            fMyIndex = yourIndex;
        }

        public void endGame(int result) {
        }


        public void setParam(int timeLimit, Action[] answerBox) {
            fTimeLimit = timeLimit;
            fAnswerBox = answerBox;
        }

        public void makeAction(object currentState) {
            State state = (State)currentState;
            Board myBoard = state.getBoard(fMyIndex);
            Board oppBoard = state.getBoard(1 - fMyIndex);
            List<Action> possibleActions = myBoard.createPossibleActions();

            int attacked = myBoard.getJamInfo().getTotalCount();  // 今見えてる自分に降る邪魔珠数
            
            // 優先順位として，攻撃しない消しができるならする．そのうち相殺数が最も大きいものを選ぶ．できないなら何もしないが石がくっつくように落とす．
            // どうしても攻撃してしまうなら最小のものを選ぶ．

            int bestScore = int.MinValue;
            Action bestAction = null;
            foreach (Action a in possibleActions) {
                int score;
                AITool_Result result = AITools.calcTotalGain(myBoard, a, false);         // その手の結果予測
                int connects = AITools.calcConnectCount(myBoard, a);  // その手がどれだけ周りの石と同色か

                if (result.IsVanish == false) {
                    score = 80*connects + fRand.Next(100);  //消去しない場合は中程度の点で，同色とくっつくほうがよい
                } else if (result.Gain > attacked) {
                    score = -(result.Gain - attacked);   //攻撃してしまう場合は低い点で，攻撃が少ないほうがよい
                } else {
                    score = 300 + 10 * (result.Gain + result.JamVanishCount) + fRand.Next(10);  //消去するが，相手に攻撃しない場合は，沢山消すのがよい．Jamが消せればなおよい．
                }
                if (score > bestScore) {
                    bestScore = score;
                    bestAction = a;
                }
            }


            fAnswerBox[0] = bestAction;
        }
    }
}
